% Start with a folder and get a list of all subfolders.
% Finds and prints names of all PNG, JPG, and TIF images in 
% that folder and all of its subfolders.
clc;
format long g;
format compact;
      
fileID = fopen('/home/dennis/Desktop/example/input/test.txt','w');   %CHANGE HERE!
      
% Ask user to confirm or change.
topLevelFolder = fullfile('/home/dennis/Desktop/example/input/test');   %CHANGE HERE!
% Get list of all subfolders.
allSubFolders = genpath(topLevelFolder);
% Parse into a cell array.
remain = allSubFolders;
listOfFolderNames = {};
while true
  [singleSubFolder, remain] = strtok(remain, ':');
  if isempty(singleSubFolder)
    break;
  end
  listOfFolderNames = [listOfFolderNames singleSubFolder];
end
numberOfFolders = length(listOfFolderNames)
       
% Process all image files in those folders.
for k = 1 : numberOfFolders
  % Get this folder and print it out.
  thisFolder = listOfFolderNames{k};
  fprintf('Processing folder %s\n', thisFolder);
       
  % Get PNG files.
  filePattern = sprintf('%s/*.png', thisFolder);
  baseFileNames = dir(filePattern);
     
  numberOfImageFiles = length(baseFileNames);
  % Now we have a list of all files in this folder.
      
  ccc=strfind(filePattern,'class_');
     
  if numberOfImageFiles >= 1
    % Go through all those image files.
    for f = 1 : numberOfImageFiles
      fullFileName = fullfile(thisFolder, baseFileNames(f).name);
      theClass = str2double(fullFileName(ccc+6:ccc+6));
      fprintf('Processing image file %s %d\n', fullFileName, theClass);
      label = theClass;
      underlineLocations = find(fullFileName == '/');
      thePath=(fullFileName(ccc:ccc+6));   %CHANGE HERE!
      fprintf(fileID,'%s %d\n',['/test/' thePath '/' baseFileNames(f).name], label);   %CHANGE HERE!
    end
  else
    fprintf('Folder %s has no image files in it.\n', thisFolder);
  end
end
     
fclose(fileID);
